package ru.dbotthepony.kstarbound.world.api

import ru.dbotthepony.kstarbound.Registry
import ru.dbotthepony.kstarbound.defs.tile.LiquidDefinition
import java.io.DataInputStream

sealed class AbstractLiquidState {
	abstract val def: Registry.Entry<LiquidDefinition>?
	abstract val level: Float
	abstract val pressure: Float
	abstract val isInfinite: Boolean

	abstract fun mutable(): MutableLiquidState
	abstract fun immutable(): ImmutableLiquidState

	companion object {
		fun skip(stream: DataInputStream) {
			stream.skipNBytes(1 + 4 + 4 + 1)
		}

		val EMPTY = ImmutableLiquidState()
	}
}
